; Script generated by the HM NIS Edit Script Wizard.
; Adapted for docsis ... (c) 2003 Evvolve Media SRL.
; needs NSIS 2.0b4 or a recent CVS snapshot (does not work with 2.0b3)
; Get NSIS at http://nsis.sourceforge.net

!include "MUI.nsh"

!define MUI_PRODUCT "docsis"
!define MUI_VERSION "0.9.3"

!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_INSTFILES

!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\README.txt"
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Icons\Setup.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Icons\normal-uninstall.ico"

!insertmacro MUI_LANGUAGE "English"

OutFile "docsis-setup-dist.exe"
InstallDir "$PROGRAMFILES\DOCSIS Configurator"
InstallDirRegKey  HKLM "Software\Microsoft\Windows\CurrentVersion\App Paths\docsis.exe" ""
LicenseData "@@buildroot@@\License.txt"
ShowInstDetails show
ShowUnInstDetails show

Section "Base DOCSIS kit" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "@@buildroot@@\src\docsis.exe"
  CreateShortCut "$DESKTOP\docsis.lnk" "$INSTDIR\docsis.exe"
  File "@@buildroot@@\License.txt"
  File "C:\cygwin\bin\cygcrypto-0.9.7.dll"
  File "C:\cygwin\bin\cygwin1.dll"
  File "@@buildroot@@\README.txt"

; In order to allow docsis to be run from everywhere, we create a batch file
; and copy that to the Windows system directory.
; We could also update the global PATH but that I don't know how to do that
; and it may require a rebooot ...
  FileOpen $9 $INSTDIR\docsis.bat w
  FileWrite $9 "@echo off$\r$\n"
  FileWrite $9 "set MIBS=ALL$\r$\n"
  FileWrite $9 "set MIBDIRS=$INSTDIR\snmp\mibs$\r$\n"
  FileWrite $9 "set PATH=%PATH%;$INSTDIR$\r$\n"
  FileWrite $9 "set SNMPCONFPATH=%PATH%;$INSTDIR\snmp\conf$\r$\n"
  FileWrite $9 "docsis.exe %1 %2 %3 %4 %5 %6 %7$\r$\n"
  FileClose $9
  CopyFiles $INSTDIR\docsis.bat $SYSDIR
; Documentation
  SetOutPath "$INSTDIR\doc"
  File "@@buildroot@@\doc\index.html"
  File "@@buildroot@@\doc\config-format.html"
  File "@@buildroot@@\doc\config-settings.html"
SectionEnd

Section "Example files" SEC02
  SetOutPath "$INSTDIR\examples"
  File "@@buildroot@@\examples\testkey.key"
  File "@@buildroot@@\examples\README.txt"
  File "@@buildroot@@\examples\packetcable_mta.cfg"
  File "@@buildroot@@\examples\keyfile"
  File "@@buildroot@@\examples\docsis20_stresstest.cfg"
  File "@@buildroot@@\examples\docsis20_no_snmp.cfg"
  File "@@buildroot@@\examples\docsis20.cfg"
  File "@@buildroot@@\examples\docsis1.1_stress_test.cfg"
  File "@@buildroot@@\examples\docsis1.1_simple.cfg"
  File "@@buildroot@@\examples\docsis1.1_oss_v3coex.cfg"
  File "@@buildroot@@\examples\docsis1.1_classifiers2.cfg"
  File "@@buildroot@@\examples\docsis1.1_classifiers.cfg"
  File "@@buildroot@@\examples\docsis1.0_filters2_oidtext.cfg"
  File "@@buildroot@@\examples\docsis1.0_filters2_oidnum.cfg"
  File "@@buildroot@@\examples\docsis1.0_filters_oidtext.cfg"
  File "@@buildroot@@\examples\docsis1.0_filters_oidnum.cfg"
  File "@@buildroot@@\examples\docsis1.0_filters_NmAccess.cfg"
  File "@@buildroot@@\examples\docsis1.0_example.cfg"
  File "@@buildroot@@\examples\docsis1.0_basic_upgrade.cfg"
  File "@@buildroot@@\examples\docsis1.0_basic_bpi.cfg"
  File "@@buildroot@@\examples\docsis1.0_basic.cfg"
  File "@@buildroot@@\examples\docsis1.0_2class_rfc2669.cfg"
  File "@@buildroot@@\examples\docsis1.0_2class_non-rfc2669.cfg"
SectionEnd

Section "SNMP MIBs" SEC03
  SetOutPath "$INSTDIR\snmp\mibs"
  File "@@netsnmproot@@\UDP-MIB.txt"
  File "@@netsnmproot@@\UCD-SNMP-MIB.txt"
  File "@@netsnmproot@@\UCD-IPFWACC-MIB.txt"
  File "@@netsnmproot@@\UCD-DLMOD-MIB.txt"
  File "@@netsnmproot@@\UCD-DISKIO-MIB.txt"
  File "@@netsnmproot@@\UCD-DEMO-MIB.txt"
  File "@@netsnmproot@@\TCP-MIB.txt"
  File "@@netsnmproot@@\SNMP-VIEW-BASED-ACM-MIB.txt"
  File "@@netsnmproot@@\SNMPv2-TM.txt"
  File "@@netsnmproot@@\SNMPv2-TC.txt"
  File "@@netsnmproot@@\SNMPv2-SMI.txt"
  File "@@netsnmproot@@\SNMPv2-MIB.txt"
  File "@@netsnmproot@@\SNMPv2-CONF.txt"
  File "@@netsnmproot@@\SNMP-USER-BASED-SM-MIB.txt"
  File "@@netsnmproot@@\SNMP-TARGET-MIB.txt"
  File "@@netsnmproot@@\SNMP-PROXY-MIB.txt"
  File "@@netsnmproot@@\SNMP-NOTIFICATION-MIB.txt"
  File "@@netsnmproot@@\SNMP-MPD-MIB.txt"
  File "@@netsnmproot@@\SNMP-FRAMEWORK-MIB.txt"
  File "@@netsnmproot@@\SNMP-COMMUNITY-MIB.txt"
  File "@@netsnmproot@@\SMUX-MIB.txt"
  File "@@netsnmproot@@\RMON-MIB.txt"
  File "@@netsnmproot@@\RFC-1215.txt"
  File "@@netsnmproot@@\RFC1213-MIB.txt"
  File "@@netsnmproot@@\RFC1155-SMI.txt"
  File "@@netsnmproot@@\NOTIFICATION-LOG-MIB.txt"
  File "@@netsnmproot@@\NET-SNMP-TC.txt"
  File "@@netsnmproot@@\NET-SNMP-MIB.txt"
  File "@@netsnmproot@@\NET-SNMP-EXAMPLES-MIB.txt"
  File "@@netsnmproot@@\NET-SNMP-AGENT-MIB.txt"
  File "@@netsnmproot@@\IPV6-UDP-MIB.txt"
  File "@@netsnmproot@@\IPV6-TCP-MIB.txt"
  File "@@netsnmproot@@\IPV6-TC.txt"
  File "@@netsnmproot@@\IPV6-MIB.txt"
  File "@@netsnmproot@@\IPV6-ICMP-MIB.txt"
  File "@@netsnmproot@@\IP-MIB.txt"
  File "@@netsnmproot@@\IP-FORWARD-MIB.txt"
  File "@@netsnmproot@@\INET-ADDRESS-MIB.txt"
  File "@@netsnmproot@@\IF-MIB.txt"
  File "@@netsnmproot@@\IF-INVERTED-STACK-MIB.txt"
  File "@@netsnmproot@@\IANA-LANGUAGE-MIB.txt"
  File "@@netsnmproot@@\IANAifType-MIB.txt"
  File "@@netsnmproot@@\IANA-ADDRESS-FAMILY-NUMBERS-MIB.txt"
  File "@@netsnmproot@@\HOST-RESOURCES-TYPES.txt"
  File "@@netsnmproot@@\HOST-RESOURCES-MIB.txt"
  File "@@netsnmproot@@\HCNUM-TC.txt"
  File "@@netsnmproot@@\EtherLike-MIB.txt"
  File "@@netsnmproot@@\AGENTX-MIB.txt"
  File "@@netsnmproot@@\DISMAN-SCRIPT-MIB.txt"
  File "@@netsnmproot@@\DISMAN-SCHEDULE-MIB.txt"
  File "@@buildroot@@\mibs\IGMP-STD-MIB.mib"
  File "@@buildroot@@\mibs\DOCS-SUBMGT-MIB.mib"
  File "@@buildroot@@\mibs\DOCS-QOS-MIB.mib"
  File "@@buildroot@@\mibs\DOCS-IF-MIB.mib"
  File "@@buildroot@@\mibs\DOCS-IF-EXT-MIB.mib"
  File "@@buildroot@@\mibs\DOCS-CABLE-DEVICE-TRAP-MIB.mib"
  File "@@buildroot@@\mibs\DOCS-CABLE-DEVICE-MIB.mib"
  File "@@buildroot@@\mibs\DOCS-BPI-MIB.mib"
  File "@@buildroot@@\mibs\DOCS-BPI2-MIB.mib"
  File "@@buildroot@@\mibs\CLAB-DEF-MIB.txt"
  File "@@buildroot@@\mibs\PKTC-SIG-MIB.mib"
  File "@@buildroot@@\mibs\PKTC-MTA-MIB.mib"
  File "@@buildroot@@\mibs\PKTC-EVENT-MIB.mib"
; We need to tell the NET-SNMP library [statically linked into docsis]
; where to find the MIB files. 

  SetOutPath "$INSTDIR\snmp\conf"
  FileOpen $9 $INSTDIR\snmp\conf\snmp.conf w
  FileWrite $9 "mibs ALL$\n"
  FileWrite $9 "mibdirs $INSTDIR\snmp\mibs$\n"
  FileClose $9
SectionEnd

Section -AdditionalIcons
  WriteIniStr "$INSTDIR\docsis.url" "InternetShortcut" "URL" "http://www.evvolve.com/docsis.html"
  WriteIniStr "$INSTDIR\cablelabs.url" "InternetShortcut" "URL" "http://www.cablelabs.com"
  CreateDirectory "$SMPROGRAMS\DOCSIS Configurator"
  CreateShortCut "$SMPROGRAMS\DOCSIS Configurator\Documentation.lnk" "$INSTDIR\doc\index.html"
  CreateShortCut "$SMPROGRAMS\DOCSIS Configurator\DOCSIS Website.lnk" "$INSTDIR\docsis.url"
  CreateShortCut "$SMPROGRAMS\DOCSIS Configurator\Cablelabs Website.lnk" "$INSTDIR\docsis.url"
  CreateShortCut "$SMPROGRAMS\DOCSIS Configurator\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\App Paths\docsis.exe" "" "$INSTDIR\docsis.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\docsis" "DisplayName" "${MUI_PRODUCT} ${MUI_VERSION}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\docsis" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\docsis" "DisplayIcon" "$INSTDIR\docsis.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\docsis" "DisplayVersion" "${MUI_VERSION}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\docsis" "URLInfoAbout" "http://www.evvolve.com/docsis.html"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\docsis" "Publisher" "Evvolve Media SRL"
SectionEnd

!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "These are the base programs needed by DOCSIS. The Cygwin libraries are included here for convenience. If you already have Cygwin installed, you would be better off compiling from source."
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "These are example configuration file (in text format). These are just examples, some of them are not useable in a real network. Make sure you understand what's in there before using them."
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} "These are the SNMP MIBs.  DOCSIS-specific MIBs are included. These files are used by docsis to decode SnmpMibObject settings in a human-readable format."
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "${MUI_PRODUCT} ${MUI_VERSION} was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove ${MUI_PRODUCT} ${MUI_VERSION} and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  Delete "$INSTDIR\docsis.exe"
  Delete "$INSTDIR\License.txt"
  Delete "$INSTDIR\cygcrypto-0.9.7.dll"
  Delete "$INSTDIR\cygwin1.dll"
  Delete "$INSTDIR\README.txt"
  Delete "$INSTDIR\docsis.bat"
  Delete "$SYSDIR\docsis.bat"
  Delete "$INSTDIR\doc\index.html"
  Delete "$INSTDIR\doc\config-format.html"
  Delete "$INSTDIR\doc\config-settings.html"
  Delete "$INSTDIR\examples\testkey.key"
  Delete "$INSTDIR\examples\README.txt"
  Delete "$INSTDIR\examples\packetcable_mta.cfg"
  Delete "$INSTDIR\examples\keyfile"
  Delete "$INSTDIR\examples\docsis20_stresstest.cfg"
  Delete "$INSTDIR\examples\docsis20_no_snmp.cfg"
  Delete "$INSTDIR\examples\docsis20.cfg"
  Delete "$INSTDIR\examples\docsis1.1_stress_test.cfg"
  Delete "$INSTDIR\examples\docsis1.1_simple.cfg"
  Delete "$INSTDIR\examples\docsis1.1_oss_v3coex.cfg"
  Delete "$INSTDIR\examples\docsis1.1_classifiers2.cfg"
  Delete "$INSTDIR\examples\docsis1.1_classifiers.cfg"
  Delete "$INSTDIR\examples\docsis1.0_filters2_oidtext.cfg"
  Delete "$INSTDIR\examples\docsis1.0_filters2_oidnum.cfg"
  Delete "$INSTDIR\examples\docsis1.0_filters_oidtext.cfg"
  Delete "$INSTDIR\examples\docsis1.0_filters_oidnum.cfg"
  Delete "$INSTDIR\examples\docsis1.0_filters_NmAccess.cfg"
  Delete "$INSTDIR\examples\docsis1.0_example.cfg"
  Delete "$INSTDIR\examples\docsis1.0_basic_upgrade.cfg"
  Delete "$INSTDIR\examples\docsis1.0_basic_bpi.cfg"
  Delete "$INSTDIR\examples\docsis1.0_basic.cfg"
  Delete "$INSTDIR\examples\docsis1.0_2class_rfc2669.cfg"
  Delete "$INSTDIR\examples\docsis1.0_2class_non-rfc2669.cfg"
  Delete "$INSTDIR\snmp\mibs\UDP-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\UCD-SNMP-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\UCD-IPFWACC-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\UCD-DLMOD-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\UCD-DISKIO-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\UCD-DEMO-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\TCP-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\SNMP-VIEW-BASED-ACM-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\SNMPv2-TM.txt"
  Delete "$INSTDIR\snmp\mibs\SNMPv2-TC.txt"
  Delete "$INSTDIR\snmp\mibs\SNMPv2-SMI.txt"
  Delete "$INSTDIR\snmp\mibs\SNMPv2-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\SNMPv2-CONF.txt"
  Delete "$INSTDIR\snmp\mibs\SNMP-USER-BASED-SM-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\SNMP-TARGET-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\SNMP-PROXY-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\SNMP-NOTIFICATION-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\SNMP-MPD-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\SNMP-FRAMEWORK-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\SNMP-COMMUNITY-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\SMUX-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\RMON-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\RFC-1215.txt"
  Delete "$INSTDIR\snmp\mibs\RFC1213-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\RFC1155-SMI.txt"
  Delete "$INSTDIR\snmp\mibs\PKTC-SIG-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\PKTC-MTA-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\PKTC-EVENT-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\NOTIFICATION-LOG-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\NET-SNMP-TC.txt"
  Delete "$INSTDIR\snmp\mibs\NET-SNMP-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\NET-SNMP-EXAMPLES-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\NET-SNMP-AGENT-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\IPV6-UDP-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\IPV6-TCP-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\IPV6-TC.txt"
  Delete "$INSTDIR\snmp\mibs\IPV6-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\IPV6-ICMP-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\IP-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\IP-FORWARD-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\INET-ADDRESS-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\IGMP-STD-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\IF-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\IF-INVERTED-STACK-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\IANA-LANGUAGE-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\IANAifType-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\IANA-ADDRESS-FAMILY-NUMBERS-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\HOST-RESOURCES-TYPES.txt"
  Delete "$INSTDIR\snmp\mibs\HOST-RESOURCES-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\HCNUM-TC.txt"
  Delete "$INSTDIR\snmp\mibs\EtherLike-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\DOCS-SUBMGT-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\DOCS-QOS-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\DOCS-IF-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\DOCS-IF-EXT-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\DOCS-CABLE-DEVICE-TRAP-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\DOCS-CABLE-DEVICE-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\DOCS-BPI-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\DOCS-BPI2-MIB.mib"
  Delete "$INSTDIR\snmp\mibs\DISMAN-SCRIPT-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\DISMAN-SCHEDULE-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\CLAB-DEF-MIB.txt"
  Delete "$INSTDIR\snmp\mibs\AGENTX-MIB.txt"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\docsis.url"
  Delete "$INSTDIR\cablelabs.url"



  Delete "$DESKTOP\docsis.lnk"
  Delete "$SMPROGRAMS\DOCSIS Configurator\Documentation.lnk"
  Delete "$SMPROGRAMS\DOCSIS Configurator\DOCSIS Website.lnk"
  Delete "$SMPROGRAMS\DOCSIS Configurator\Cablelabs Website.lnk"
  Delete "$SMPROGRAMS\DOCSIS Configurator\Uninstall.lnk"

  RMDir "$SMPROGRAMS\DOCSIS Configurator"
  RMDir "$INSTDIR\snmp\mibs"
  RMDir "$INSTDIR\snmp\conf"
  RMDir "$INSTDIR\examples"
  RMDir "$INSTDIR"

  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\docsis"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\App Paths\docsis.exe"
  SetAutoClose true
SectionEnd

